# CesiumTerrainProvider

#### new Cesium.CesiumTerrainProvider(options)
Core/CesiumTerrainProvider.js 67

A `TerrainProvider` that accesses terrain data in a Cesium terrain format.

Name | Type | Description
--- | --- | ---

`options`

Object

Object with the following properties:

Name | Type | Default | Description
--- | --- | --- | ---
`url` | Resource | String | Promise.<Resource> | Promise.<String> |  | The URL of the Cesium terrain server.
`requestVertexNormals` | Boolean | `false` | optional Flag that indicates if the client should request additional lighting information from the server, in the form of per vertex normals if available.
`requestWaterMask` | Boolean | `false` | optional Flag that indicates if the client should request per tile water masks from the server, if available.
`requestMetadata` | Boolean | `true` | optional Flag that indicates if the client should request per tile metadata from the server, if available.
`ellipsoid` | Ellipsoid |  | optional The ellipsoid. If not specified, the WGS84 ellipsoid is used.
`credit` | Credit | String |  | optional A credit for the data source, which is displayed on the canvas.

##### Example:

    // Create Arctic DEM terrain with normals.
    var viewer = new Cesium.Viewer('cesiumContainer', {
        terrainProvider : new Cesium.CesiumTerrainProvider({
            url : Cesium.IonResource.fromAssetId(3956),
            requestVertexNormals : true
        })
    });

##### See:

- createWorldTerrain
- TerrainProvider

### Members

#### readonly availability : TileAvailability
Core/CesiumTerrainProvider.js 1143

Gets an object that can be used to determine availability of terrain from this provider, such as at points and in rectangles. This function should not be called before `CesiumTerrainProvider#ready` returns true. This property may be undefined if availability information is not available. Note that this reflects tiles that are known to be available currently. Additional tiles may be discovered to be available in the future, e.g. if availability information exists deeper in the tree rather than it all being discoverable at the root. However, a tile that is available now will not become unavailable in the future.

#### readonly credit : Credit
Core/CesiumTerrainProvider.js 960

Gets the credit to display when this terrain provider is active. Typically this is used to credit the source of the terrain. This function should not be called before `CesiumTerrainProvider#ready` returns true.

#### readonly errorEvent : Event
Core/CesiumTerrainProvider.js 947

Gets an event that is raised when the terrain provider encounters an asynchronous error. By subscribing to the event, you will be notified of the error and can potentially recover from it. Event listeners are passed an instance of `TileProviderError`.

#### readonly hasMetadata : Boolean
Core/CesiumTerrainProvider.js 1074

Gets a value indicating whether or not the requested tiles include metadata. This function should not be called before `CesiumTerrainProvider#ready` returns true.

#### readonly hasVertexNormals : Boolean
Core/CesiumTerrainProvider.js 1051

Gets a value indicating whether or not the requested tiles include vertex normals. This function should not be called before `CesiumTerrainProvider#ready` returns true.

#### readonly hasWaterMask : Boolean
Core/CesiumTerrainProvider.js 1029

Gets a value indicating whether or not the provider includes a water mask. The water mask indicates which areas of the globe are water rather than land, so they can be rendered as a reflective surface with animated waves. This function should not be called before `CesiumTerrainProvider#ready` returns true.

#### readonly ready : Boolean
Core/CesiumTerrainProvider.js 1001

Gets a value indicating whether or not the provider is ready for use.

#### readonly readyPromise : Promise.<Boolean>
Core/CesiumTerrainProvider.js 1013

Gets a promise that resolves to true when the provider is ready for use.

#### readonly requestMetadata : Boolean
Core/CesiumTerrainProvider.js 1125

Boolean flag that indicates if the client should request metadata from the server. Metadata is appended to the standard tile mesh data only if the client requests the metadata and if the server provides a metadata.

#### readonly requestVertexNormals : Boolean
Core/CesiumTerrainProvider.js 1097

Boolean flag that indicates if the client should request vertex normals from the server. Vertex normals data is appended to the standard tile mesh data only if the client requests the vertex normals and if the server provides vertex normals.

#### readonly requestWaterMask : Boolean
Core/CesiumTerrainProvider.js 1111

Boolean flag that indicates if the client should request a watermask from the server. Watermask data is appended to the standard tile mesh data only if the client requests the watermask and if the server provides a watermask.

#### readonly tilingScheme : GeographicTilingScheme
Core/CesiumTerrainProvider.js 981

Gets the tiling scheme used by this provider. This function should not be called before `CesiumTerrainProvider#ready` returns true.

### Methods

#### getLevelMaximumGeometricError(level) → Number
Core/CesiumTerrainProvider.js 1163

Gets the maximum geometric error allowed in a tile at a given level.

Name | Type | Description
--- | --- | ---
`level` | Number | The tile level for which to get the maximum geometric error.

##### Returns:

The maximum geometric error.

#### getTileDataAvailable(x, y, level) → Boolean|undefined
Core/CesiumTerrainProvider.js 1177

Determines whether data for a tile is available to be loaded.

Name | Type | Description
--- | --- | ---
`x` | Number | The X coordinate of the tile for which to request geometry.
`y` | Number | The Y coordinate of the tile for which to request geometry.
`level` | Number | The level of the tile for which to request geometry.

##### Returns:

Undefined if not supported or availability is unknown, otherwise true or false.

#### loadTileDataAvailability(x, y, level) → undefined|Promise.<void>
Core/CesiumTerrainProvider.js 1215

Makes sure we load availability data for a tile

Name | Type | Description
--- | --- | ---
`x` | Number | The X coordinate of the tile for which to request geometry.
`y` | Number | The Y coordinate of the tile for which to request geometry.
`level` | Number | The level of the tile for which to request geometry.

##### Returns:

Undefined if nothing need to be loaded or a Promise that resolves when all required tiles are loaded

#### requestTileGeometry(x, y, level, request) → Promise.<TerrainData>|undefined
Core/CesiumTerrainProvider.js 814

Requests the geometry for a given tile. This function should not be called before `CesiumTerrainProvider#ready` returns true. The result must include terrain data and may optionally include a water mask and an indication of which child tiles are available.

Name | Type | Description
--- | --- | ---
`x` | Number | The X coordinate of the tile for which to request geometry.
`y` | Number | The Y coordinate of the tile for which to request geometry.
`level` | Number | The level of the tile for which to request geometry.
`request` | Request | optional The request object. Intended for internal use only.

##### Returns:

A promise for the requested geometry. If this method returns undefined instead of a promise, it is an indication that too many requests are already pending and the request will be retried later.

##### Throws:

- DeveloperError : This function must not be called before `CesiumTerrainProvider#ready` returns true.